classification
Title: test_asyncio fails always
Type: Stage: resolved
Components: asyncio Versions: Python 3.6
process
Status: closed Resolution: works for me
Dependencies: Superseder:
Assigned To: Nosy List: Thomas Knox, asvetlov, ned.deily, torsava, vstinner, xiang.zhang, yselivanov, zach.ware
Priority: normal Keywords:

Created on 2017-03-23 21:30 by Thomas Knox, last changed 2017-12-20 20:51 by asvetlov. This issue is now closed.

Messages (8)
msg290059 - (view) Author: Thomas Knox (Thomas Knox) Date: 2017-03-23 21:30
Downloaded Python 3.6.1 source code onto CentOS 7.3 (64 bit), Fedora 25 (64 bit), Ubuntu 16.10 (64 bit) and Raspberry Pi 8.0 (32 bit).

Configured with
./configure --enable-shared --enable-optimizations --enable-loadable-sqlite-extensions --disable-ipv6 --with-system-expat --with-system-ffi --with-threads

On every platform, when running the profile generation code, test_asyncio fails with this error message:

0:06:45 [ 25/405] test_asyncio
Executing <Task finished coro=<CoroutineTests.test_async_def_wrapped.<locals>.start() done, defined at /home/pi/Source/Python-3.6.1/Lib/test/test_asyncio/test_pep492.py:150> result=None created at /home/pi/Source/Python-3.6.1/Lib/asyncio/base_events.py:446> took 2.106 seconds
0:13:11 [ 26/405] test_asyncore -- test_asyncio failed in 6 min 27 sec
msg290060 - (view) Author: Ned Deily (ned.deily) * (Python committer) Date: 2017-03-23 21:43
There have been other reports (e.g. Issue29712) of failures when using --enable-optimizations with --enable-shared.  Can you see if removing --enable-shared makes a difference for your configurations?
msg290066 - (view) Author: Thomas Knox (Thomas Knox) Date: 2017-03-23 22:46
I changed the configuration flags to be:

pi@pi3:~/Source/Python-3.6.1 $ ./configure --enable-optimizations --enable-loadable-sqlite-extensions --disable-ipv6 --with-system-expat --with-system-ffi --with-threads

The profiling filed again with:

0:04:47 [ 25/405] test_asyncio
Executing <Task finished coro=<CoroutineTests.test_async_def_wrapped.<locals>.start() done, defined at /home/pi/Source/Python-3.6.1/Lib/test/test_asyncio/test_pep492.py:150> result=None created at /home/pi/Source/Python-3.6.1/Lib/asyncio/base_events.py:446> took 1.187 seconds
0:08:45 [ 26/405] test_asyncore -- test_asyncio failed in 3 min 59 sec

But at least it failed 2.5 minutes faster. :)
msg290067 - (view) Author: Zachary Ware (zach.ware) * (Python committer) Date: 2017-03-23 22:51
Does the build fail, or just the test in the profile generation?
msg290068 - (view) Author: Thomas Knox (Thomas Knox) Date: 2017-03-23 22:57
The build succeeds, but the profile generation fails (only the test_asyncio portion fails), then does a new profiled build after the profiling run completes which succeeds.

Then, when doing a 'make install', it builds the entire thing again and runs another profile generation run which also fails, then a new profiled build. Possibly because the first profile run failed?

On an RPi, this is exceedingly painful as a build/profile/build cycle takes about 10 hours. So doing it twice is double-unfun.
msg290075 - (view) Author: Xiang Zhang (xiang.zhang) * (Python committer) Date: 2017-03-24 03:51
> Then, when doing a 'make install', it builds the entire thing again and runs another profile generation run which also fails, then a new profiled build. Possibly because the first profile run failed?

This is a known issue. Some build commands always clear the environment and rebuild. See #29243.
msg293335 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2017-05-09 16:07
Can someone test again with a development branch? The bpo-29243 has been fixed in 2.7, 3.5, 3.6 and master (3.7) branches thanks to Tomas Orsava!
msg308812 - (view) Author: Andrew Svetlov (asvetlov) * (Python committer) Date: 2017-12-20 20:51
Confirm: no problems on master (Ubuntu 17.10).

Closing the issue.
History
Date User Action Args
2017-12-20 20:51:31asvetlovsetstatus: open -> closed

nosy: + asvetlov
messages: + msg308812

resolution: works for me
stage: resolved
2017-05-09 16:07:23vstinnersetnosy: + torsava
messages: + msg293335
2017-03-24 03:51:21xiang.zhangsetnosy: + xiang.zhang
messages: + msg290075
2017-03-23 22:57:41Thomas Knoxsetmessages: + msg290068
2017-03-23 22:51:32zach.waresetnosy: + zach.ware
messages: + msg290067
2017-03-23 22:46:05Thomas Knoxsetmessages: + msg290066
2017-03-23 21:43:59ned.deilysetnosy: + vstinner, yselivanov, ned.deily
messages: + msg290060

components: + asyncio, - Tests
type: compile error ->
2017-03-23 21:30:44Thomas Knoxcreate